#include "guiao4.h"


void TestReadWrite();
void TestSides();
void TestPoligono();

void Task_A();
void TASK_B();
void TASK_C();
void TASK_D();

void TASK_G();
void TASK_H();
void TASK_I();

int main()
{
	//TestReadWrite();
	//TestSides();
	//TestPoligono();
	
	//Task_A();
	//TASK_B();
	//TASK_C();
	//TASK_D();

	//TASK_G();
	//TASK_H();
	TASK_I();
}

void TestReadWrite()
{
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	//u.WriteVector(std::cout, u.Vertices);
}

void TestSides()
{
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	std::cout << u.GetSides() << std::endl;
}

void TestPoligono()
{
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	//u.VerificarPoligono();
	if(u.poligono == 1)
		std::cout << "poligono." << std::endl;
	else
		std::cout << "nao poligono." << std::endl;
}

void Task_A()
{
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	//u.VerificarPoligono();
	if(u.poligono == 1)
		std::cout << u.GetSides() << " " << "C" << std::endl;
	else
		std::cout << u.GetSides() << " " << "O" << std::endl;
}

void TASK_B()
{
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	if(u.IsPoligono())
		std::cout << static_cast<int>(u.GetSides()) << std::endl;
	else
		std::cout << "NO" << std::endl;
}

void TASK_C()
{
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	double area=u.AreaPoligono();
	if(u.IsPoligono())
	{
		if(area>=1)
			std::cout << static_cast<int>(area) << std::endl;
		else
			std::cout << static_cast<int>((area*-1)) << std::endl;
	}
	else
		std::cout << "NO" << std::endl;
}

void TASK_D()
{
	std::string resposta;
	Utilities u;
	u.Read(std::cin);
	u.GetVertices();
	u.GetArestas();

	int n;
	std::vector<mas::Point> pontos;
	std::cin >> n;
	for(int i=0; i<n; i++)
	{
		mas::Point p;
		int x, y;
		std::cin >> x >> y;
		p.Set(x, y);
		pontos.push_back(p);
	}
	if(u.IsPoligono())
	{
		for(int i=0; i<static_cast<int>(pontos.size()); i++)
		{
			if(u.IsPerimeter(pontos[i]))
				resposta += "?";
			else
			{
				int posicao = u.InsideOut(pontos[i]);
				if(posicao == 0)
				{
					resposta += "O";
				}
				else
				{
					if(posicao == 1)
						resposta += "I";
				}
			}
			std::cout << resposta << std::endl;
		}
	}
	else
		std::cout << "NO" << std::endl;
}

void TASK_G()
{
	Utilities u;
	u.MATRIZREAD(std::cin);
	u.Matriz_WRITE();
}

void TASK_H()
{
	Utilities u;
	std::vector<mas::Point> pontos;
	std::vector<mas::Point> respostas;
	u.MATRIZREAD(std::cin);
	u.MATRIXREAD_PONTOS(std::cin);

	for(int i=0; i<static_cast<int>(pontos.size()); i++)
	{
		std::vector<mas::Point> resultados = u.VIZINHOS(pontos[i]);
		std::cout << static_cast<int>(resultados.size());
		if(static_cast<int>(resultados.size())!=0)
		{
			for(int j=0; j<static_cast<int>(resultados.size()); j++)
			{
				std::cout << " " << resultados[j].X() << " " << resultados[j].Y();
			}
		}
		std::cout << std::endl;
	}
}

void TASK_I()
{
	Utilities u;
	u.MATRIZREAD(std::cin);
	int S;
	std::cin >> S;
	std::vector <std::set<mas::Point> > TodosVizinhos;
	for(int i=0; i<S;i++)
	{
		u.MATRIXREAD_PONTOS(std::cin);
		std::set<mas::Point> VizinhosAgrupados;
		for(int k=0;k<static_cast<int> (u.pontos.size());k++)
		{
			std::vector <mas::Point> PontosVizinhos = u.VIZINHOS(u.pontos[k]);
			for(int l=0;l<static_cast<int>(PontosVizinhos.size());l++)
			VizinhosAgrupados.insert(PontosVizinhos[l]);	
		}
		TodosVizinhos.push_back(VizinhosAgrupados); 
	}

	for(int i=0; i<S;i++)
	{
		std::cout << static_cast<int>(TodosVizinhos[i].size());
		if(static_cast<int>(TodosVizinhos[i].size())!=0)
		{
			int ctr = 0;
			for(std::set<mas::Point>::const_iterator j = TodosVizinhos[i].begin(); j != TodosVizinhos[i].end(); j++)
			{
				if(ctr<10)
				{
					std::cout << " " << (*j).X() << " " << (*j).Y();
					}
					else
					{
						std::cout << " " << "...";
						break;
					}
				ctr++;
			}
		}
		std::cout << std::endl;
	}
}
